Transition = require("transition")
Gamestate = require("gamestate")
Signal = require("signal")

local State_1 = require("states.state_1")
local State_2 = require("states.state_2")

Signal.register("switch", function ()

    Transition:start()

    Gamestate.switch(
        (Gamestate.current() == State_1)
            and State_2 or State_1
    )

end)

Gamestate.switch(State_1)

function love.keyreleased(k)
    if k == "space" then
        Signal.emit("switch")
    end
end

function love.update(dt)

    Gamestate:update()

    if Transition.isPlaying then
        Transition:update(dt)
    end

end

function love.draw()

    Gamestate.draw()

    if Transition.isPlaying then
        Transition:draw()
    end

    love.graphics.print("Press \"SPACE\" to switch")

end